# hnwizard.pl
# wizard stuff for hacknet
# Copyright 2002 Peter Hanely, hanelyp@calweb.com

#    This file is part of hacknet.

#    hacknet is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.

#    hacknet is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

#    You should have received a copy of the GNU General Public License
#    along with hacknet; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

# extra / override commands if wizard is set on player
%wizard = ('b'=>\&build, 'm'=>\&monster, 'M'=>\&monsterstat,
	'l'=>\&reload, 'S'=>\&wizsave, 'D'=>\&shutdown);

# reload data files without killing players
sub reload
{ my ($wizard) = @_;
  # notify all players of reload
  foreach $player (@players)
  { &notify ($player, "reloading DB from files, hang on"); }
  $wizard->{'mode'} = \&reload2;
}

sub reload2
{ my ($wizard) = @_;
  # mark all 'monsters' as norespawn in case they're held by a player
  foreach $monster (@monsters)
  { $monster->{'norespawn'}++; }

  # clear maps and lists
  undef %players;
  undef %monsters;
  undef @monsters;
  undef %tiles;
  undef @levels;
  undef @levelstat;
  
  # and reload
  &loadall();
  $wizard->{'mode'} = undef;
}

# save stuff
sub wizsave
{
}

sub shutdown
{ $shutdown++; }
